$(document).ready(function () {
    firebase.auth().onAuthStateChanged(function(user) {
        if (user) {
            firebase.database().ref('users/' + firebase.auth().currentUser.uid + "/history").on('value', function (snapshot) {
                var historyList = snapshot.val();
                for (var historyItem in historyList) {
                    // console.log(history+': '+.message);
                    var itemData = historyList[historyItem];

                    if(!isInFuture(itemData.deliveryTime) && !hasHiddenSegment(itemData.segments)){
                        var item =  "<li class=\"list-group-item\">" +
                            "<h4 class=\"list-group-item-heading\">Message: " + itemData.message + " <\/h4>"+
                            "<p class=\"list-group-item-text\">Delivery time:  " + formatDate(new Date(itemData.deliveryTime)) + " <\/p>" +
                            "<p class=\"list-group-item-text\">Segments: " + itemData.segments + "  <\/p>" +
                            "<\/li>";

                        $("#listview").append(item); 
                    }
                }
            });
        }
    });
});

var hiddenSegments = [];
function hasHiddenSegment(segments) {
    if(!segments || !hiddenSegments || hiddenSegments.length == 0){
        return false;
    }
    segments = JSON.parse(segments);
    for (var i = 0; i < segments.length; ++i) {
        var segment = segments[i];
        for (var j = 0; j < hiddenSegments.length; ++j) {
            if(segment == hiddenSegments[j]){
                return true;
            }
        }

    }
    return false;
}

function isInFuture(deliveryTime) {
    var now = new Date();
    if (deliveryTime > now) {
        return true;
    }
    return false;
}

function formatDate(date) {
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var ampm = hours >= 12 ? 'pm' : 'am';
    hours = hours % 12;
    hours = hours ? hours : 12; // the hour '0' should be '12'
    minutes = minutes < 10 ? '0'+minutes : minutes;
    var strTime = hours + ':' + minutes + ' ' + ampm;
    return date.getMonth()+1 + "/" + date.getDate() + "/" + date.getFullYear() + "  " + strTime;
}


