
$(document).ready(function () {
  firebase.auth().onAuthStateChanged(function(user) {
    if (user) { 
      $("#username-text").text("(" + firebase.auth().currentUser.providerData[0].email + ")");
    }
  });
});

/*
Firebase does not allow creating a user without sign-in after.
To allow the user to stay the same we have to create a temp app instance
 then logout the user and delete the app. Check below for more details:
 http://stackoverflow.com/questions/37517208/firebase-kicks-out-current-user
 */
function signup(e) {

  // Get Data from UI
  var username = $("#signup-username").val();
  var password = $("#signup-password").val();
  var androidApiKey = $("#android-api-key").val();
  var iosApiKey = $("#ios-api-key").val();
  var restApiKey = $("#rest-api-key").val();

  // Prepare temp app config instance
  var config = {
    apiKey: "AIzaSyBQN9GToSw8bYWXkPrhueMV43ah9FP0eyY",
    authDomain: "accounts-abc79.firebaseapp.com",
    databaseURL: "https://accounts-abc79.firebaseio.com",
    storageBucket: ""
  };
  var secondaryApp = firebase.initializeApp(config, "Secondary");
  var clearSecondaryApp = function (result) {
    secondaryApp.auth().signOut();
    secondaryApp.delete();
  };

  // Send request
  var userTag =  $("#status");
  secondaryApp.auth().createUserWithEmailAndPassword(username, password).then(function (result) {
    secondaryApp.database().ref('users/' + secondaryApp.auth().currentUser.uid).set({
      androidApiKey: androidApiKey,
      iosApiKey: iosApiKey,
      restApiKey: restApiKey
    }).then(function (result) {
          userTag.addClass("success");
          userTag.text("The user '" + username+ "' successfuly created");
          clearSecondaryApp();
    },
    function (error) {
      console.log(error);
      userTag.addClass("error");
      userTag.text(error.message);
      clearSecondaryApp()
    });

  }, function (error) {
    userTag.addClass("error");
    userTag.text(error.message);
    clearSecondaryApp();
  });

}